/***************************************************************
 * Name:      nuevoproyecto.cpp
 * Purpose:   Code for Dialog nuevoProyecto
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2024-07-16
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#include "nuevoproyecto.h"

BEGIN_EVENT_TABLE(nuevoProyecto, wxDialog)
    EVT_CLOSE(nuevoProyecto::OnClose)
END_EVENT_TABLE()

nuevoProyecto::nuevoProyecto(wxWindow *wnd, datosProyecto &datos, wxString titulo)
    : wxDialog(wnd, -1, titulo)
{
    wxBoxSizer *boxVertical;
    wxBoxSizer *boxHorizontal;
    wxTextValidator valTexto = wxTextValidator(wxFILTER_SPACE|wxFILTER_ALPHANUMERIC, &datos.Nombre());
    wxIntegerValidator<int> valEntero (&datos.NBits(), 2, 64);

    boxVertical = new wxBoxSizer(wxVERTICAL);

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    boxHorizontal->Add(new wxStaticText(this, wxID_ANY, _T("&Nombre:")), wxSizerFlags().Border());
    ctrlNombre = new wxTextCtrl(this, idNombre, wxEmptyString, wxDefaultPosition, wxSize(200, wxDefaultCoord), 0, valTexto);
    boxHorizontal->Add(ctrlNombre, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    boxHorizontal->Add(new wxStaticText(this, wxID_ANY, _T("Nº &bits:")), wxSizerFlags().Border());
    ctrlNBits = new wxTextCtrl(this, idNBits, wxEmptyString, wxDefaultPosition, wxSize(200, wxDefaultCoord), 0, valEntero);
    boxHorizontal->Add(ctrlNBits, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());

    boxVertical->Add(CreateStdDialogButtonSizer(wxOK | wxCANCEL), wxSizerFlags().Border());

    SetSizerAndFit(boxVertical);
}

void nuevoProyecto::OnClose(wxCloseEvent &event)
{
    Destroy();
}
