/***************************************************************
 * Name:      verificarproyecto.cpp
 * Purpose:   Code for Dialog nuevoProyecto
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2024-07-16
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#include "verificar.h"

BEGIN_EVENT_TABLE(verificarProyecto, wxDialog)
    EVT_CLOSE(verificarProyecto::OnClose)
END_EVENT_TABLE()

verificarProyecto::verificarProyecto(wxWindow *wnd, datosProyecto &datos)
    : wxDialog(wnd, -1, _T("Verificar función"))
{
    wxBoxSizer *boxVertical;
    wxString cad;
    int i;
    int nCombinaciones = 1 << datos.NBits();

    boxVertical = new wxBoxSizer(wxVERTICAL);

    boxVertical->Add(new wxStaticText(this, wxID_ANY, Salida(datos)), wxSizerFlags().Border());
    boxVertical->Add(new wxStaticText(this, wxID_ANY, _T("&Tabla de verdad:")), wxSizerFlags().Border());
    ctrlLista = new wxListCtrl(this, idLista, wxDefaultPosition, wxSize(300, 400), wxLC_REPORT);
    ctrlLista->AppendColumn(_T("Minterm"));
    ctrlLista->AppendColumn(_T("Bits"));
    ctrlLista->AppendColumn(_T("Definición"));
    ctrlLista->AppendColumn(_T("Función"));
    for(i=0; i<nCombinaciones; i++) {
        cad = "";
        cad << i;
        ctrlLista->InsertItem(i, cad);
        ctrlLista->SetItem(i, 1, datos.ToBinary(i));
        if(datos.Minterm(i)) {
            ctrlLista->SetItem(i, 2, _("M"));
        }
        if(datos.Redundant(i)) {
            ctrlLista->SetItem(i, 2, _("R"));
        }
        if(datos.Cumple(i)) ctrlLista->SetItem(i, 3, _("X"));
    }
    boxVertical->Add(ctrlLista, wxSizerFlags().Border());

    boxVertical->Add(CreateStdDialogButtonSizer(wxOK), wxSizerFlags().Border());

    SetSizerAndFit(boxVertical);
}

void verificarProyecto::OnClose(wxCloseEvent &event)
{
    Destroy();
}

wxString verificarProyecto::Salida(datosProyecto& datos) {
    wxString salida="";
    bool primero=true;
    salida << "S = ";
    for(size_t i=0; i<datos.TablaFinal().size(); i++) {
        if(datos.TablaFinal()[i].Esencial()) {
            if(!primero) { salida << "+ "; }
            else primero=false;
            for(int j=datos.TablaFinal()[i].Imp()->Tam()-1; j>=0; j--) {
                if(datos.TablaFinal()[i].Imp()->Bit()[j] == '1') salida << "I" << datos.NBits()-j << " ";
                if(datos.TablaFinal()[i].Imp()->Bit()[j] == '0') salida << "I" << datos.NBits()-j << "' ";
            }
        }
    }
    return salida;
}
