/***************************************************************
 * Name:      wx_Quine_McCluskeyMain.h
 * Purpose:   Defines Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-07-15
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifndef WX_QUINE_MCCLUSKEYMAIN_H
#define WX_QUINE_MCCLUSKEYMAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "wx_Quine_McCluskeyApp.h"

#include <wx/button.h>
#include <wx/statline.h>
#include <wx/dirdlg.h>
#include <wx/imagpng.h>
#include <libxml/xpath.h>
#include "datos.h"

class wx_Quine_McCluskeyFrame: public wxFrame
{
    public:
        wx_Quine_McCluskeyFrame(wxFrame *frame, const wxString& title);
        ~wx_Quine_McCluskeyFrame();

    protected:
        enum
        {
            idMenuQuit = 1000,
            idMenuNew,
            idMenuEdit,
            idMenuDefine,
            idMenuSimplify,
            idMenuVerify,
            idMenuSave,
            idMenuSaveAs,
            idMenuLoad,
            idMenuAbout
        };
    private:
        wxMenu* fileMenu;
        wxStaticBitmap* bm;
        datosProyecto data;
        void Save();
        void Load(wxString file);
        bool ExisteNodo(xmlXPathContextPtr xpathCtx, const xmlChar *ruta);
        wxString LeeNodoString(xmlXPathContextPtr xpathCtx, const xmlChar *ruta);
        int LeeNodoInt(xmlXPathContextPtr xpathCtx, const xmlChar *ruta);
        void LeeMinterms(xmlXPathContextPtr xpathCtx, const xmlChar *ruta);
        void LeeRedundantes(xmlXPathContextPtr xpathCtx, const xmlChar *ruta);
        void OnClose(wxCloseEvent& event);
        void OnSize(wxSizeEvent& event);
        void ActualizarStatusBar();
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnNuevoProyecto(wxCommandEvent& event);
        void OnEditarProyecto(wxCommandEvent& event);
        void OnDefinirProyecto(wxCommandEvent& event);
        void OnGuardarProyecto(wxCommandEvent& event);
        void OnGuardarComoProyecto(wxCommandEvent& event);
        void OnCargarProyecto(wxCommandEvent& event);
        void OnSimplify(wxCommandEvent& event);
        void OnVerify(wxCommandEvent& event);
        DECLARE_EVENT_TABLE()
};

#endif // WX_QUINE_MCCLUSKEYMAIN_H
